package fxKaljoja;

import DynamicComboBox.DynamicComboBox;
import fi.jyu.mit.fxgui.Dialogs;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.collections.FXCollections;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.*;

import java.net.URL;
import java.util.ResourceBundle;
import Luokat.*;
import SearchableObject.*;

/**
 * @author miikk
 * @version 29.1.2025
 *
 */
public class KalojaGUIController implements Initializable, ModalControllerInterface<String> {
	@FXML private ComboBox<String> koko;

	@FXML private DynamicComboBox lajit;

	@FXML private TextField vieheVarit;

	@FXML private DynamicComboBox vieheet;

	private String ReissuTagi;
	
   @Override
   public void initialize(URL url, ResourceBundle resourceBundle){
		koko.setItems(FXCollections.observableArrayList("Sintti", "Keskikokoinen", "Iso", "Kalavalhe"));



   }

   



	 @FXML private void handlePoista(){
		 Poista();
	 }

	 private void Poista() {
		 Dialogs.showMessageDialog("poistutaan! Mutta ei toimi vielä");
	 }

	@FXML private void handleTallenna() {
		Tallenna();
	}

	 private void Tallenna() {

	   Saalis s = new Saalis(koko.getSelectionModel().getSelectedItem(), lajit.getSelectionModel().getSelectedItem(), Integer.parseInt(ReissuTagi));
	   System.out.println("saalis : koko " + s.getKoko() + " laji " + s.getLaji() + " id " + s.getSaaliinId() + " Reissulta " + s.getReissunTagi());
	   Viehe v  = new Viehe(s.getSaaliinId(), vieheet.getSelectionModel().getSelectedItem(), vieheVarit.getText());
	   System.out.println("saatu vieheellä " + v.getTypyppi() + " " + v.getVari());
	   String tiedot = s.tiedotTallenusMuodossa();
	   System.out.println("Tiedot tallennetaan muodossa: " + tiedot);
	   Saalis s2 = new Saalis(tiedot);
	   System.out.println("saalis muutettuna tiedoista: koko " + s2.getKoko() + " laji " + s2.getLaji() + " id " + s2.getSaaliinId() + " Reissulta " + s2.getReissunTagi());
		 
	 }
	

	@Override
	public String getResult() {
		return "";
	}

	@Override
	public void setDefault(String s) {
	   ReissuTagi = s;
	}

	@Override
	public void handleShown() {

	}
}

